local Exclusion = {
	MT_GHOST;
	MT_OVERLAY;
	MT_PLAYER;
	MT_THOK;
	MT_TAILSOVERLAY;
	MT_METALJETFUME;
	MT_SPINDUST;
}

local Freezable = {
	MT_RING;
	MT_FLINGRING;
	MT_METALSONIC_RACE;
	MT_METALSONIC_BATTLE;
	MT_SKYBOX;
	MT_TNTBARREL;
	MT_PROXIMITYTNT;
	MT_BIGTUMBLEWEED;
	MT_LITTLETUMBLEWEED;
	MT_SUSPICIOUSFACESTABBERSTATUE;
	MT_MACEPOINT;
	MT_CHAINMACEPOINT;
	MT_CHAINPOINT;
	MT_SMALLGRABCHAIN;
	MT_BIGGRABCHAIN;
	MT_SMALLMACECHAIN;
	MT_BIGMACECHAIN;
	MT_SMALLMACE;
	MT_BIGMACE;
	MT_CANNONLAUNCHER;
	MT_BIGMINE;
	MT_SPIKEBALL;
	MT_GOOP;
	MT_EGGROBO1;
	MT_EGGROBO1JET;
	MT_ROSY;
	MT_GLAREGOYLE;
	MT_GLAREGOYLEUP;
	MT_GLAREGOYLEDOWN;
	MT_GLAREGOYLELONG;
	MT_BLUEGARGOYLE;
	MT_GREENFLAME;
	MT_FLAMEJET;
	MT_VERTICALFLAMEJET;
	MT_FLAMEJETFLAME;
	MT_FJSPINAXISA;
	MT_FJSPINAXISB;
	MT_FLAMEJETFLAMEB;
	MT_LAVAFALL;
	MT_LAVAFALL_LAVA;
	MT_LAVAFALLROCK;
	MT_FBOMB;
	MT_FALLINGROCK;
	MT_ROCKCRUMBLE1;
	MT_ROCKCRUMBLE2;
	MT_ROCKCRUMBLE3;
	MT_ROCKCRUMBLE4;
	MT_ROCKCRUMBLE5;
	MT_ROCKCRUMBLE6;
	MT_ROCKCRUMBLE7;
	MT_ROCKCRUMBLE8;
	MT_ROCKCRUMBLE9;
	MT_ROCKCRUMBLE10;
	MT_ROCKCRUMBLE11;
	MT_ROCKCRUMBLE12;
	MT_ROCKCRUMBLE13;
	MT_ROCKCRUMBLE14;
	MT_ROCKCRUMBLE15;
	MT_ROCKCRUMBLE16;
	MT_GFZFLOWER1;
	MT_GFZFLOWER2;
	MT_GFZFLOWER3;
	MT_BLUEBERRYBUSH;
	MT_BERRYBUSH;
	MT_BUSH;
	MT_GFZTREE;
	MT_GFZBERRYTREE;
	MT_GFZCHERRYTREE;
	MT_CHECKERTREE;
	MT_CHECKERSUNSETTREE;
	MT_FHZTREE;
	MT_FHZPINKTREE;
	MT_POLYGONTREE;
	MT_BUSHTREE;
	MT_BUSHREDTREE;
	MT_SPRINGTREE;
	MT_THZFLOWER1;
	MT_THZFLOWER2;
	MT_THZFLOWER3;
	MT_THZTREE;
	MT_THZTREEBRANCH;
	MT_ALARM;
	MT_CORAL1;
	MT_CORAL2;
	MT_CORAL3;
	MT_CORAL4;
	MT_CORAL5;
	MT_BLUECRYSTAL;
	MT_KELP;
	MT_ANIMALGAETOP;
	MT_ANIMALGAESEG;
	MT_WATERDROP;
	MT_WATERDRIP;
	MT_SEAWEED;
	MT_FLAME;
	MT_FLAMEPARTICLE;
	MT_FIREBARPOINT;
	MT_BIGFIREBAR;
	MT_SMALLFIREBAR;
	MT_CEZFLOWER;
	MT_CEZBANNER1;
	MT_CEZBANNER2;
	MT_CEZBUSH1;
	MT_CEZBUSH2;
	MT_CANDLE;
	MT_CANDLEPRICKET;
	MT_FLAMEHOLDER;
	MT_FIRETORCH;
	MT_WAVINGFLAG1;
	MT_WAVINGFLAG2;
	MT_WAVINGFLAGSEG1;
	MT_WAVINGFLAGSEG2;
	MT_DUSTDEVIL;
	MT_DUSTLAYER;
	MT_ARIDDUST;
	MT_BIGFERN;
	MT_BIGFERNLEAF;
	MT_JUNGLEPALM;
	MT_XMASBLUEBERRYBUSH;
	MT_XMASBERRYBUSH;
	MT_XMASBUSH;
	MT_DBALL;
	MT_SMALLBUBBLE;
	MT_MEDIUMBUBBLE;
	MT_EXTRALARGEBUBBLE;
	MT_PARTICLE;
	MT_PARTICLEGEN;
	MT_COIN;
	MT_SPIKE;
	MT_WALLSPIKE;
	MT_WALLSPIKEBASE;
	MT_FIREBALL;
	MT_SHELL;
	MT_PUMA;
	MT_PUMATRAIL;
	MT_EXPLODE;
	MT_UWEXPLODE;
	MT_DUST;
	MT_BOSSEXPLODE;
	MT_SONIC3KBOSSEXPLODE;
	MT_CYBRAKDEMON_VILE_EXPLOSION;
	MT_CYBRAKDEMON_ELECTRIC_BARRIER;
	MT_CYBRAKDEMON_FLAMEREST;
	MT_CYBRAKDEMON_TARGET_RETICULE;
	MT_CYBRAKDEMON_TARGET_DOT;
	MT_CYBRAKDEMON_NAPALM_BOMB_LARGE;
	MT_CYBRAKDEMON_NAPALM_BOMB_SMALL;
	MT_CYBRAKDEMON_NAPALM_FLAMES;
	MT_MSSHIELD_FRONT;
}

local Flickies = {MT_FLICKY_01,MT_FLICKY_02,MT_FLICKY_03,MT_FLICKY_04,MT_FLICKY_05,MT_FLICKY_06,MT_FLICKY_07,MT_FLICKY_08,MT_FLICKY_09,MT_FLICKY_10,MT_FLICKY_11,MT_FLICKY_12,MT_FLICKY_13,MT_FLICKY_14,MT_FLICKY_15,MT_FLICKY_16,MT_SECRETFLICKY_01,MT_SECRETFLICKY_02}

rawset(_G, "TS_Exclusion", Exclusion)
rawset(_G, "TS_Inclusion", Freezable)
rawset(_G, "TS_Flickies", Flickies)
rawset(_G, "TS_Hooks", {})

rawset(_G, "TS_InTable", function(Table, String)
	for i,v in pairs(Table) do
		if v == String then
			return true
		end
	end
	return false
end)

rawset(_G, "TS_GetHook", function(object_type)
	if TS_Hooks[object_type] then
		return TS_Hooks[object_type]
	end
	return nil
end)

rawset(_G, "TS_NewHook", function(object_type, ...)
	if not TS_Hooks[object_type] then
		addHook("MobjThinker", ..., object_type)
		TS_Hooks[object_type] = ...
	end
end)